DACS_CONF(8)               DACS Web Services Manual               DACS_CONF(8)



[1mNAME[0m
       dacs_conf - display [1mDACS [22mconfiguration directives

[1mSYNOPSIS[0m
       [1mdacs_conf [22m[[34m[1mdacsoptions[0m[1m[22m[1]]

[1mDESCRIPTION[0m
       This program is part of the [1mDACS [22msuite.

       The [1mdacs_conf [22mweb service processes and displays [1mDACS [22mconfiguration
       files (see [34m[1mdacs.conf(5)[0m[1m[22m[2]).

       If XML output is selected, a document conforming to
       [34m[1mdacs_conf_reply.dtd[0m[1m[22m[3] is returned.

       Although the order in which clauses appear in configuration files can
       be important, the order of configuration directives is for the most
       part not significant. The exception is the [34m[1mEVAL[0m[1m[22m[4] directive. These
       directives are listed in the order in which they would be evaluated,
       and their [4munevaluated[24m values appear in the output.

           [1mNote[0m
           This program is also available as a [1mDACS [22mutility, [34m[1mdacsconf(1)[0m[1m[22m[5].
           Because [34m[1mdacs_admin(8)[0m[1m[22m[6] provides the same functionality and more,
           [1mdacs_conf [22mmay be removed in a future release.

           [1mSecurity[0m
           Because the configuration might reveal information that could be
           taken advantage of by an attacker, only the [1mDACS [22madministrator
           should be able to run this command. Accordingly, a [1mDACS [22mACL
           restricts use of this web service to a DACS administrator.

[1mOPTIONS[0m
   [1mWeb Service Arguments[0m
       In addition to the [34m[1mstandard CGI arguments[0m[1m[22m[7], [1mdacs_conf [22munderstands the
       following CGI arguments:

       [4mDIRECTIVE[0m
           This optional, repeatable argument is a comma-separated list of
           directive names or variable references to be displayed. This is
           similar to the [4mdirective-name[24m arguments to [34m[1mdacsconf(1)[0m[1m[22m[5].

           An example of a directive name is JURISDICTION_NAME. An example of
           a variable reference is [4m${Conf::jurisdiction_name:i}[24m.

       [4mVARS[0m
           If the value of this optional argument is "yes", the effect on
           output formatting is the same as when the [1m-vars [22mflag is give to
           [34m[1mdacsconf(1)[0m[1m[22m[5]. The default value is "no".

[1mFILES[0m
       [34m[1mconf.css[0m[1m[22m[8]

[1mDIAGNOSTICS[0m
       The program exits 0 if everything was fine, 1 if an error occurred.

[1mSEE ALSO[0m
       [34m[1mdacsconf(1)[0m[1m[22m[5], [34m[1mdacs.conf(5)[0m[1m[22m[2]

[1mAUTHOR[0m
       Distributed Systems Software ([34m[1mwww.dss.ca[0m[1m[22m[9])

[1mCOPYING[0m
       Copyright (C) 2003-2012 Distributed Systems Software. See the
       [34m[1mLICENSE[0m[1m[22m[10] file that accompanies the distribution for licensing
       information.

[1mNOTES[0m
        1. dacsoptions
           http://dacs.dss.ca/man/dacs.1.html#dacsoptions

        2. dacs.conf(5)
           http://dacs.dss.ca/man/dacs.conf.5.html

        3. dacs_conf_reply.dtd
           http://dacs.dss.ca/man/../dtd-xsd/dacs_conf_reply.dtd

        4. EVAL
           http://dacs.dss.ca/man/dacs.conf.5.html#EVAL

        5. dacsconf(1)
           http://dacs.dss.ca/man/dacsconf.1.html

        6. dacs_admin(8)
           http://dacs.dss.ca/man/dacs_admin.8.html

        7. standard CGI arguments
           http://dacs.dss.ca/man/dacs.services.8.html#standard_cgi_args

        8. conf.css
           http://dacs.dss.ca/man//css/conf.css

        9. www.dss.ca
           http://www.dss.ca

       10. LICENSE
           http://dacs.dss.ca/man/../misc/LICENSE



DACS 1.4.28a                      01/29/2013                      DACS_CONF(8)
