DACSCONF(1)                  DACS Commands Manual                  DACSCONF(1)



[1mNAME[0m
       dacsconf - display configuration directives

[1mSYNOPSIS[0m
       [1mdacsconf [22m[[34m[1mdacsoptions[0m[1m[22m[1]] [[1m-vars[22m] [[4mdirective-name[24m...]

       [1mdacsconf [22m[[1m-item_types[22m]

[1mDESCRIPTION[0m
       This program is part of the [1mDACS [22msuite.

       The [1mdacsconf [22mutility processes [1mDACS [22mconfiguration files (see
       [34m[1mdacs.conf(5)[0m[1m[22m[2]) and outputs to stdout the values of directives or
       variable references currently in effect for the specified jurisdiction.

       Although the order in which clauses appear in configuration files can
       be important, the order of configuration directives is for the most
       part not significant. The exception is the [34m[1mEVAL[0m[1m[22m[3] directive. These
       directives are listed in the order in which they would be evaluated,
       and their [4munevaluated[24m values appear in the output.

       This program is also available as a [1mDACS [22mweb service, [34m[1mdacs_conf(8)[0m[1m[22m[4].

           [1mSecurity[0m
           Because the configuration might reveal information that could be
           taken advantage of by an attacker, only the [1mDACS [22madministrator
           should be able to run this command.

[1mOPTIONS[0m
       [1m-item_types[0m
           List the names of all predefined item types. The presence of a name
           does not imply that [1mDACS [22mhas been configured to use the item type.

       [1m-vars[0m
           By default, directives that appear within a clause (e.g., <Auth> or
           <Roles>) are emitted in the context of that clause. This option
           "flattens" the output by emitting it in the form of [1mDACS [22mvariables.

           For example, the STYLE directive in an Auth section having an id of
           foo will appear as [4mAUTH.FOO.STYLE[24m in the output.

           All variables in the [4mConf[24m namespace are displayed, including those
           set by EVAL.

       [4mdirective-name[0m
           One or more directive names or variable references may be provided
           to limit the output. It is not an error if a [4mdirective-name[24m is not
           defined.

[1mFILES[0m
       [34m[1mconf.css[0m[1m[22m[5]

[1mDIAGNOSTICS[0m
       The program exits 0 if everything was fine, 1 if an error occurred.
       Error messages are printed to stderr.

[1mSEE ALSO[0m
       [34m[1mdacs_conf(8)[0m[1m[22m[4], [34m[1mdacs.conf(5)[0m[1m[22m[2]

[1mAUTHOR[0m
       Distributed Systems Software ([34m[1mwww.dss.ca[0m[1m[22m[6])

[1mCOPYING[0m
       Copyright (C) 2003-2012 Distributed Systems Software. See the
       [34m[1mLICENSE[0m[1m[22m[7] file that accompanies the distribution for licensing
       information.

[1mNOTES[0m
        1. dacsoptions
           http://dacs.dss.ca/man/dacs.1.html#dacsoptions

        2. dacs.conf(5)
           http://dacs.dss.ca/man/dacs.conf.5.html

        3. EVAL
           http://dacs.dss.ca/man/dacs.conf.5.html#EVAL

        4. dacs_conf(8)
           http://dacs.dss.ca/man/dacs_conf.8.html

        5. conf.css
           http://dacs.dss.ca/man//css/conf.css

        6. www.dss.ca
           http://www.dss.ca

        7. LICENSE
           http://dacs.dss.ca/man/../misc/LICENSE



DACS 1.4.28a                      01/29/2013                       DACSCONF(1)
